Index: /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.cpp	(revision 1158)
@@ -1332,311 +1381,383 @@
     {
         case 2:
-#line 61 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 63 "yacc_parser.yacc" /* yacc.c:1646  */
     { /* Nothing to do */ }
-#line 1337 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1386 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 3:
-#line 62 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 64 "yacc_parser.yacc" /* yacc.c:1646  */
     { parsed = (yyvsp[-1].filterNode); }
-#line 1343 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1392 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 4:
-#line 66 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 68 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarValExprNode(*(yyvsp[0].str)); delete (yyvsp[0].str); }
-#line 1349 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1398 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 5:
-#line 67 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 69 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarVarExprNode(*(yyvsp[0].str)); delete (yyvsp[0].str); }
-#line 1355 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1404 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 6:
-#line 68 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 70 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "add", (yyvsp[0].scalarNode)); }
-#line 1361 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1410 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 7:
-#line 69 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 71 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "minus", (yyvsp[0].scalarNode)); }
-#line 1367 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1416 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 8:
-#line 70 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 72 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "mult", (yyvsp[0].scalarNode)); }
-#line 1373 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1422 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 9:
-#line 71 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 73 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "div", (yyvsp[0].scalarNode)); }
-#line 1379 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1428 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 10:
-#line 72 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 74 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarUnaryOpExprNode("neg", (yyvsp[0].scalarNode)); }
-#line 1385 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1434 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 11:
-#line 73 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 75 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "pow", (yyvsp[0].scalarNode)); }
-#line 1391 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1440 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 12:
-#line 74 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 76 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "eq", (yyvsp[0].scalarNode)); }
-#line 1397 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1446 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 13:
-#line 75 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 77 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "lt", (yyvsp[0].scalarNode)); }
-#line 1403 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1452 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 14:
-#line 76 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 78 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "gt", (yyvsp[0].scalarNode)); }
-#line 1409 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1458 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 15:
-#line 77 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 79 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "le", (yyvsp[0].scalarNode)); }
-#line 1415 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1464 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 16:
-#line 78 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 80 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "ge", (yyvsp[0].scalarNode)); }
-#line 1421 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1470 "yacc_parser.cpp" /* yacc.c:1646  */
     break;
 
   case 17:
-#line 79 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 81 "yacc_parser.yacc" /* yacc.c:1646  */
+    { (yyval.scalarNode) = new CScalarBinaryOpExprNode((yyvsp[-2].scalarNode), "ne", (yyvsp[0].scalarNode)); }
+#line 1476 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 18:
+#line 82 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.scalarNode) = new CScalarTernaryOpExprNode((yyvsp[-4].scalarNode), "cond", (yyvsp[-2].scalarNode), (yyvsp[0].scalarNode));}
+#line 1482 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 19:
+#line 83 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = (yyvsp[-1].scalarNode); }
-#line 1427 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 18:
-#line 80 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1488 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 20:
+#line 84 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.scalarNode) = new CScalarUnaryOpExprNode(*(yyvsp[-3].str), (yyvsp[-1].scalarNode)); delete (yyvsp[-3].str); }
-#line 1433 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 19:
-#line 84 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1494 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 21:
+#line 88 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldExprNode(*(yyvsp[0].str)); delete (yyvsp[0].str); }
-#line 1439 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 20:
-#line 85 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1500 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 22:
+#line 89 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterTemporalFieldExprNode(*(yyvsp[0].str)); delete (yyvsp[0].str); }
-#line 1445 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 21:
-#line 86 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1506 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 23:
+#line 90 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "add", (yyvsp[0].filterNode)); }
-#line 1451 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 22:
-#line 87 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1512 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 24:
+#line 91 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "minus", (yyvsp[0].filterNode)); }
-#line 1457 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 23:
-#line 88 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1518 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 25:
+#line 92 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "mult", (yyvsp[0].filterNode)); }
-#line 1463 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 24:
-#line 89 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1524 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 26:
+#line 93 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "div", (yyvsp[0].filterNode)); }
-#line 1469 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 25:
-#line 90 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1530 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 27:
+#line 94 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterUnaryOpExprNode("neg", (yyvsp[0].filterNode)); }
-#line 1475 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 26:
-#line 91 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1536 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 28:
+#line 95 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "pow", (yyvsp[0].filterNode)); }
-#line 1481 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 27:
-#line 92 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1542 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 29:
+#line 96 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "eq", (yyvsp[0].filterNode)); }
-#line 1487 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 28:
-#line 93 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1548 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 30:
+#line 97 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "lt", (yyvsp[0].filterNode)); }
-#line 1493 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 29:
-#line 94 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1554 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 31:
+#line 98 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "gt", (yyvsp[0].filterNode)); }
-#line 1499 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 30:
-#line 95 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1560 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 32:
+#line 99 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "le", (yyvsp[0].filterNode)); }
-#line 1505 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 31:
-#line 96 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1566 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 33:
+#line 100 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "ge", (yyvsp[0].filterNode)); }
-#line 1511 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 32:
-#line 97 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1572 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 34:
+#line 101 "yacc_parser.yacc" /* yacc.c:1646  */
+    { (yyval.filterNode) = new CFilterFieldFieldOpExprNode((yyvsp[-2].filterNode), "ne", (yyvsp[0].filterNode)); }
+#line 1578 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 35:
+#line 102 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = (yyvsp[-1].filterNode); }
-#line 1517 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 33:
-#line 98 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1584 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 36:
+#line 103 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterScalarScalarFieldOpExprNode((yyvsp[-4].scalarNode), "cond",(yyvsp[-2].scalarNode), (yyvsp[0].filterNode));}
+#line 1590 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 37:
+#line 104 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterScalarFieldScalarOpExprNode((yyvsp[-4].scalarNode), "cond",(yyvsp[-2].filterNode), (yyvsp[0].scalarNode));}
+#line 1596 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 38:
+#line 105 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterScalarFieldFieldOpExprNode((yyvsp[-4].scalarNode), "cond",(yyvsp[-2].filterNode), (yyvsp[0].filterNode));}
+#line 1602 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 39:
+#line 106 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterFieldScalarScalarOpExprNode((yyvsp[-4].filterNode), "cond",(yyvsp[-2].scalarNode), (yyvsp[0].scalarNode));}
+#line 1608 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 40:
+#line 107 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterFieldScalarFieldOpExprNode((yyvsp[-4].filterNode), "cond",(yyvsp[-2].scalarNode), (yyvsp[0].filterNode));}
+#line 1614 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 41:
+#line 108 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterFieldFieldScalarOpExprNode((yyvsp[-4].filterNode), "cond",(yyvsp[-2].filterNode), (yyvsp[0].scalarNode));}
+#line 1620 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 42:
+#line 109 "yacc_parser.yacc" /* yacc.c:1646  */
+    {(yyval.filterNode) = new CFilterFieldFieldFieldOpExprNode((yyvsp[-4].filterNode), "cond",(yyvsp[-2].filterNode), (yyvsp[0].filterNode));}
+#line 1626 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 43:
+#line 110 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "add", (yyvsp[0].scalarNode)); }
-#line 1523 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 34:
-#line 99 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1632 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 44:
+#line 111 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "add", (yyvsp[0].filterNode)); }
-#line 1529 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 35:
-#line 100 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1638 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 45:
+#line 112 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "minus", (yyvsp[0].scalarNode)); }
-#line 1535 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 36:
-#line 101 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1644 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 46:
+#line 113 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "minus", (yyvsp[0].filterNode)); }
-#line 1541 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 37:
-#line 102 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1650 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 47:
+#line 114 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "mult", (yyvsp[0].scalarNode)); }
-#line 1547 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 38:
-#line 103 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1656 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 48:
+#line 115 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "mult", (yyvsp[0].filterNode)); }
-#line 1553 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 39:
-#line 104 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1662 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 49:
+#line 116 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "div", (yyvsp[0].scalarNode)); }
-#line 1559 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 40:
-#line 105 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1668 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 50:
+#line 117 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "div", (yyvsp[0].filterNode)); }
-#line 1565 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 41:
-#line 106 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1674 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 51:
+#line 118 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "pow", (yyvsp[0].scalarNode)); }
-#line 1571 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 42:
-#line 107 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1680 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 52:
+#line 119 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "eq", (yyvsp[0].scalarNode)); }
-#line 1577 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 43:
-#line 108 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1686 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 53:
+#line 120 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "eq", (yyvsp[0].filterNode)); }
-#line 1583 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 44:
-#line 109 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1692 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 54:
+#line 121 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "lt", (yyvsp[0].scalarNode)); }
-#line 1589 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 45:
-#line 110 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1698 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 55:
+#line 122 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "lt", (yyvsp[0].filterNode)); }
-#line 1595 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 46:
-#line 111 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1704 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 56:
+#line 123 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "gt", (yyvsp[0].scalarNode)); }
-#line 1601 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 47:
-#line 112 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1710 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 57:
+#line 124 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "gt", (yyvsp[0].filterNode)); }
-#line 1607 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 48:
-#line 113 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1716 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 58:
+#line 125 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "le", (yyvsp[0].scalarNode)); }
-#line 1613 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 49:
-#line 114 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1722 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 59:
+#line 126 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "le", (yyvsp[0].filterNode)); }
-#line 1619 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 50:
-#line 115 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1728 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 60:
+#line 127 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "ge", (yyvsp[0].scalarNode)); }
-#line 1625 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 51:
-#line 116 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1734 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 61:
+#line 128 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "ge", (yyvsp[0].filterNode)); }
-#line 1631 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-  case 52:
-#line 117 "yacc_parser.yacc" /* yacc.c:1646  */
+#line 1740 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 62:
+#line 129 "yacc_parser.yacc" /* yacc.c:1646  */
+    { (yyval.filterNode) = new CFilterFieldScalarOpExprNode((yyvsp[-2].filterNode), "ne", (yyvsp[0].scalarNode)); }
+#line 1746 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 63:
+#line 130 "yacc_parser.yacc" /* yacc.c:1646  */
+    { (yyval.filterNode) = new CFilterScalarFieldOpExprNode((yyvsp[-2].scalarNode), "ne", (yyvsp[0].filterNode)); }
+#line 1752 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+  case 64:
+#line 131 "yacc_parser.yacc" /* yacc.c:1646  */
     { (yyval.filterNode) = new CFilterUnaryOpExprNode(*(yyvsp[-3].str), (yyvsp[-1].filterNode)); delete (yyvsp[-3].str); }
-#line 1637 "yacc_parser.cpp" /* yacc.c:1646  */
-    break;
-
-
-#line 1641 "yacc_parser.cpp" /* yacc.c:1646  */
+#line 1758 "yacc_parser.cpp" /* yacc.c:1646  */
+    break;
+
+
+#line 1762 "yacc_parser.cpp" /* yacc.c:1646  */
       default: break;
     }
@@ -1866,5 +1987,5 @@
   return yyresult;
 }
-#line 119 "yacc_parser.yacc" /* yacc.c:1906  */
+#line 133 "yacc_parser.yacc" /* yacc.c:1906  */
 
 
Index: /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.hpp	(revision 1158)
@@ -60,8 +60,11 @@
     LE = 270,
     GE = 271,
-    LEFT_PARENTHESIS = 272,
-    RIGHT_PARENTHESIS = 273,
-    END = 274,
-    NEG = 275
+    NE = 272,
+    LEFT_PARENTHESIS = 273,
+    RIGHT_PARENTHESIS = 274,
+    QUESTION_MARK = 275,
+    COLON = 276,
+    END = 277,
+    NEG = 278
   };
 #endif
@@ -78,5 +81,5 @@
   xios::IFilterExprNode* filterNode;
 
-#line 81 "yacc_parser.hpp" /* yacc.c:1909  */
+#line 84 "yacc_parser.hpp" /* yacc.c:1909  */
 };
 # define YYSTYPE_IS_TRIVIAL 1
Index: /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.yacc
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.yacc	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/yacc_parser.yacc	(revision 1158)
@@ -42,9 +42,11 @@
 %token <str> VAR ID AVERAGE
 %token PLUS MINUS TIMES DIVIDE POWER
-%token EQ LT GT LE GE
+%token EQ LT GT LE GE NE
 %token LEFT_PARENTHESIS RIGHT_PARENTHESIS
+%token QUESTION_MARK COLON
 %token <str> END
 
-%left EQ LT GT LE GE
+%nonassoc QUESTION_MARK COLON
+%left EQ LT GT LE GE NE
 %left PLUS MINUS
 %left TIMES DIVIDE
@@ -77,4 +79,6 @@
           | Expression LE Expression  { $$ = new CScalarBinaryOpExprNode($1, "le", $3); }
           | Expression GE Expression  { $$ = new CScalarBinaryOpExprNode($1, "ge", $3); }
+          | Expression NE Expression  { $$ = new CScalarBinaryOpExprNode($1, "ne", $3); }
+          | Expression QUESTION_MARK Expression COLON Expression {$$ = new CScalarTernaryOpExprNode($1, "cond", $3, $5);} 
           | LEFT_PARENTHESIS Expression RIGHT_PARENTHESIS    { $$ = $2; }
           | ID LEFT_PARENTHESIS Expression RIGHT_PARENTHESIS { $$ = new CScalarUnaryOpExprNode(*$1, $3); delete $1; }
@@ -95,5 +99,13 @@
           | Field_expr LE Field_expr { $$ = new CFilterFieldFieldOpExprNode($1, "le", $3); }
           | Field_expr GE Field_expr { $$ = new CFilterFieldFieldOpExprNode($1, "ge", $3); }
+          | Field_expr NE Field_expr { $$ = new CFilterFieldFieldOpExprNode($1, "ne", $3); }
           | LEFT_PARENTHESIS Field_expr RIGHT_PARENTHESIS	{ $$ = $2; }
+          | Expression QUESTION_MARK Expression COLON Field_expr {$$ = new CFilterScalarScalarFieldOpExprNode($1, "cond",$3, $5);}
+          | Expression QUESTION_MARK Field_expr COLON Expression {$$ = new CFilterScalarFieldScalarOpExprNode($1, "cond",$3, $5);}
+          | Expression QUESTION_MARK Field_expr COLON Field_expr {$$ = new CFilterScalarFieldFieldOpExprNode($1, "cond",$3, $5);}
+          | Field_expr QUESTION_MARK Expression COLON Expression {$$ = new CFilterFieldScalarScalarOpExprNode($1, "cond",$3, $5);}
+          | Field_expr QUESTION_MARK Expression COLON Field_expr {$$ = new CFilterFieldScalarFieldOpExprNode($1, "cond",$3, $5);}
+          | Field_expr QUESTION_MARK Field_expr COLON Expression {$$ = new CFilterFieldFieldScalarOpExprNode($1, "cond",$3, $5);}
+          | Field_expr QUESTION_MARK Field_expr COLON Field_expr {$$ = new CFilterFieldFieldFieldOpExprNode($1, "cond",$3, $5);}
           | Field_expr PLUS Expression   { $$ = new CFilterFieldScalarOpExprNode($1, "add", $3); }
           | Expression PLUS Field_expr   { $$ = new CFilterScalarFieldOpExprNode($1, "add", $3); }
@@ -115,4 +127,6 @@
           | Field_expr GE Expression { $$ = new CFilterFieldScalarOpExprNode($1, "ge", $3); }
           | Expression GE Field_expr { $$ = new CFilterScalarFieldOpExprNode($1, "ge", $3); }
+          | Field_expr NE Expression { $$ = new CFilterFieldScalarOpExprNode($1, "ne", $3); }
+          | Expression NE Field_expr { $$ = new CFilterScalarFieldOpExprNode($1, "ne", $3); }
           | ID LEFT_PARENTHESIS Field_expr RIGHT_PARENTHESIS { $$ = new CFilterUnaryOpExprNode(*$1, $3); delete $1; }
           ;
Index: /XIOS/dev/dev_olga/src/server.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/server.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/server.cpp	(revision 1158)
@@ -298,5 +298,4 @@
     void CServer::finalize(void)
     {
-
       CTimer::get("XIOS").suspend() ;
      
@@ -328,4 +327,5 @@
       report(0)<<"Performance report : Time spent in processing events : "<<CTimer::get("Process events").getCumulatedTime()<<endl  ;
       report(0)<<"Performance report : Ratio : "<<CTimer::get("Process events").getCumulatedTime()/CTimer::get("XIOS server").getCumulatedTime()*100.<<"%"<<endl  ;
+      report(100)<<CTimer::getAllCumulatedTime()<<endl ;
     }
 
@@ -352,5 +352,4 @@
          if (finished && contextList.empty()) stop=true ;
          eventScheduler->checkEvent() ;
-
        }
        CTimer::get("XIOS server").suspend() ;
@@ -422,5 +421,5 @@
        MPI_Status status ;
        int flag ;
-       static void* buffer ;
+       static char* buffer ;
        static MPI_Request request ;
        static bool recept=false ;
@@ -438,5 +437,5 @@
            MPI_Get_count(&status,MPI_CHAR,&count) ;
            buffer=new char[count] ;
-           MPI_Irecv(buffer,count,MPI_CHAR,rank,1,CXios::globalComm,&request) ;
+           MPI_Irecv((void*)buffer,count,MPI_CHAR,rank,1,CXios::globalComm,&request) ;
            recept=true ;
          }
@@ -451,6 +450,6 @@
            rank=status.MPI_SOURCE ;
            MPI_Get_count(&status,MPI_CHAR,&count) ;
-           recvContextMessage(buffer,count) ;
-           delete [] buffer;
+           recvContextMessage((void*)buffer,count) ;
+           delete [] buffer ;
            recept=false ;
          }
@@ -540,5 +539,5 @@
            MPI_Get_count(&status,MPI_CHAR,&count) ;
            buffer=new char[count] ;
-           MPI_Irecv(buffer,count,MPI_CHAR,root,2,intraComm,&request) ;
+           MPI_Irecv((void*)buffer,count,MPI_CHAR,root,2,intraComm,&request) ;
            recept=true ;
          }
@@ -552,5 +551,5 @@
            MPI_Get_count(&status,MPI_CHAR,&count) ;
            eventScheduler->registerEvent(nbContexts,hashId);
-//           registerContext(buffer,count) ;
+//           registerContext((void*)buffer,count) ;
 //           delete [] buffer ;
            recept=false ;
@@ -685,13 +684,4 @@
       id = getRank();
 
-//      if (!CXios::usingServer2)
-//        id = getRank();
-//      else
-//      {
-//        if (serverLevel == 1)
-//          id = rank_;
-//        else
-//          id = poolId;
-//      }
       fileNameClient << fileName << "_" << std::setfill('0') << std::setw(numDigit) << id << ext;
       fb->open(fileNameClient.str().c_str(), std::ios::out);
Index: /XIOS/dev/dev_olga/src/test/test_regular.f90
===================================================================
--- /XIOS/dev/dev_olga/src/test/test_regular.f90	(revision 1157)
+++ /XIOS/dev/dev_olga/src/test/test_regular.f90	(revision 1158)
@@ -18,8 +18,8 @@
   INTEGER :: comm  
   INTEGER :: ierr
-  INTEGER :: size, rank
-
-  INTEGER :: nlon = 5 !100 
-  INTEGER :: nlat = 5 !100
+  INTEGER :: sizeComm, rank    ! SIZE is a fortran function
+
+  INTEGER :: nlon = 100 
+  INTEGER :: nlat = 100
   INTEGER :: ncell 
   INTEGER :: ilat, ilon, ind
Index: /XIOS/dev/dev_olga/src/timer.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/timer.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/timer.cpp	(revision 1158)
@@ -3,4 +3,6 @@
 #include <string>
 #include <map>
+#include <iostream>
+#include <sstream>
 #include "tracer.hpp"
 
@@ -57,3 +59,11 @@
     return it->second;
   }
+
+  string CTimer::getAllCumulatedTime(void)
+  {
+    std::ostringstream strOut ;
+    for(std::map<std::string,CTimer>::iterator it=allTimer.begin();it!=allTimer.end();++it)
+      strOut<<"Timer : "<<it->first<<"    -->   cumulated time : "<<it->second.getCumulatedTime()<<std::endl ;
+    return strOut.str() ;
+  }
 }
Index: /XIOS/dev/dev_olga/src/timer.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/timer.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/timer.hpp	(revision 1158)
@@ -23,4 +23,5 @@
       static double getTime(void);
       static CTimer& get(std::string name);
+      static std::string getAllCumulatedTime(void) ;
   };
 }
